import json
from ...services import  printer

def add(dep_pairs):
    arr = dep_pairs.split(',')

    with open('job.json', 'r') as f:
        obj = json.loads(f.read())

    if not obj.get('TaskDag'):
        obj['TaskDag'] = {}
    if not obj['TaskDag'].get('Dependencies'):
        obj['TaskDag']['Dependencies'] = {}

    taskDescMap = obj['TaskDag']['TaskDescMap'] or {}

    for n in arr:
        pair = n.split(':')

        if not pair[0] in taskDescMap:
            raise  Exception('Not found task %s' % pair[0])

        v = obj['TaskDag']['Dependencies'].get(pair[0])
        if not v:
            obj['TaskDag']['Dependencies'][pair[0]] = []

        if len(pair)==2:
            if not pair[1] in taskDescMap:
                raise  Exception('Not found task %s' % pair[1])

            obj['TaskDag']['Dependencies'][pair[0]].append(pair[1])
            print('add dependency relationship from %s to %s' % (pair[0],pair[1]))

    with open('job.json', 'w') as f:
        f.write(json.dumps(obj, indent=2))

    return printer.done()
