import json
from ...services import  printer
from terminal import confirm
def remove(dep_pairs, yes=False):

    if not yes and yes != 'true':
        try:
            if not confirm('To remove these dependencies, are you sure'):
                return 0
        except KeyboardInterrupt:
            print('')
            return 0

    arr = dep_pairs.split(',')

    with open('job.json', 'r') as f:
        obj = json.loads(f.read())

    if not obj.get('TaskDag'):
        obj['TaskDag'] = {}
    if not obj['TaskDag'].get('Dependencies'):
        obj['TaskDag']['Dependencies'] = {}

    deps = obj['TaskDag']['Dependencies']

    for n in arr:
        pair = n.split(':')
        arr = deps.get(pair[0])

        if arr != None:
            if len(pair)==1 or (len(pair)==2 and not pair[1]):
                deps.pop(pair[0])
                print('remove dependency relationship from %s to any other task' % pair[0])
            elif len(pair)==2:
                if pair[1] in deps[pair[0]]:
                    vset = set(deps[pair[0]])
                    vset = vset.remove(pair[1])
                    if vset:
                        deps[pair[0]] = [i for i in vset]
                    else:
                        deps[pair[0]] = []
                    print('remove dependency relationship from %s to %s' % (pair[0],pair[1]))


    with open('job.json', 'w') as f:
        f.write(json.dumps(obj, indent=2))

    n = printer.done()
    return 1+n
